/*
RICHO RTC 5C372A ̃f[^V[g
lTXIIC FAQ http://www2.renesas.com/faq/ja/mi800/f_v85iic.html
Qlɂ

̃\[XR[h CC0 pubNEhC񋟂łB
https://creativecommons.org/publicdomain/zero/1.0/deed.ja

 kyoutan.jpn.org
*/

#include "sfr_r8m12a.h"
#include "ecudefine.h"
#include "rtc.h"
#include "wait.h"
#include "uart.h"

volatile struct st_clock clock;

void RTC_readtime(void);
bool RTC_settime(void);
unsigned int RTC_read(unsigned char addr);
bool RTC_write(unsigned char,unsigned char);
unsigned char byte2bcd(char a);
unsigned int bcd2int(unsigned int a);

/*
const char week[][4]=
{
	"SUN",
	"MON",
	"TUE",
	"WED",
	"THU",
	"FRI",
	"SAT"
};
*/

// X^[gRfBV̂
inline void RTC_start(void)
{
	unsigned char a;
	
	RTC_SCL_OUT();
	RTC_SDA_OUT();
	RTC_SCL=1;
	RTC_SDA=1;
	RTC_SCL_IN();
	RTC_SDA_IN();
	for(a=0; a<255; a++)
	{
		if((RTC_SCL==1)&&(RTC_SDA==1)) break;	// SCL,SDAHɂȂ̂҂(oX̂҂)
		wait10us(5);
		//putch('S');
	}
	RTC_SCL_OUT();
	RTC_SDA_OUT();
	wait10us(100);
	
	RTC_SDA=0;
	wait10us(5);	// ZbgAbv 4.0usȏ

	RTC_SCL=0;
	wait10us(5);
}

//XgbvRfBV̂
inline void RTC_stop(void)
{
	unsigned int a;
	
	RTC_SCL=0;
	RTC_SCL_OUT();
	wait10us(2);
	RTC_SDA=0;
	RTC_SDA_OUT();
	wait10us(5);

	RTC_SCL=1;
	wait10us(5);	// ZbgAbv 4.0usȏ

	RTC_SCL_IN();
	for(a=0; a<255; a++)
	{
		wait10us(5);
		if(RTC_SCL==1) break;	// SCLHɂȂ̂҂iX[uEGCgĂ҂j
		//putch('P');
	}

	RTC_SDA=1;
	RTC_SDA_IN();
	for(a=0; a<255; a++)
	{
		wait10us(5);
		if(RTC_SDA==1) break;	// SDAHɂȂ̂҂ił̓EFCg͂ȂƎvǔÔ߁j
		//putch('P');
	}
	wait10us(100);	// XgbvRfBV 61usȏJĎ̃ANZXs
	
	RTC_SDA_IN();
}

inline void RTC_clkout(void)
{
	unsigned char a;
	
	RTC_SCL_OUT();
	RTC_SCL=1;
	wait10us(2);	// Hi 4.0us ȏ 100kHzȉ

	RTC_SCL_IN();
	for(a=0; a<255; a++)
	{
		if(RTC_SCL==1) break;	// SCLHɂȂ̂҂iX[uEFCgĂ҂j
		wait10us(5);
		//putch('C');
	}
	RTC_SCL_OUT();

	RTC_SCL=0;
	wait10us(2);	// Hi 4.7us ȏ
}

inline void RTC_ACKout(void)
{
	RTC_SDA=0;
	RTC_SDA_OUT();	// SDAo
	RTC_clkout();
	RTC_SDA=1;
	RTC_SDA_IN();	// SDA
}

bool RTC_1write(unsigned char data)
{
	unsigned char i;
	bool err = FALSE;
	
	RTC_SDA_OUT();	// SDAo
	for (i=0; i<8; i++)
	{
		if ((data & 0x80)==0x80) RTC_SDA=1;
		                    else RTC_SDA=0;

		RTC_clkout();
		data=data << 1;
	}
	RTC_SDA=1;
	RTC_SDA_IN();	// SDA
	for (i=0; i<255; i++)	// 255*50=12ms炢Ń^CAEg
	{
		if (RTC_SDA==0)	// ACK ҂
		{
			err=TRUE;
			//puts("WRITE ACK L OK\r\n");
			break;
		}
		//putch('A');
		wait10us(5);
	}

	RTC_clkout();
	
	return err;
}

unsigned char RTC_1read(void)
{
	int i,j;
	unsigned char data=0;
	RTC_SDA=1;
	RTC_SDA_IN();	// SDA
	for (i=0; i<8; i++)
	{
		RTC_SCL=1;
		wait10us(2);	// Hi 4.0us ȏ 100kHzȉ
		data=data << 1;
		data=data | RTC_SDA;
		RTC_SCL=0;
		wait10us(2);	// Low 4.7us ȏ
	}
	return data;
}

unsigned char byte2bcd(char a)
{
	return ((a/10) << 4) + a%10;
}

unsigned int bcd2int(unsigned int a)
{
	unsigned int i;
	i=((a >> 12) & 0xF)*1000
	 +((a >>  8) & 0xF)*100
	 +((a >>  4) & 0xF)*10
	 +( a        & 0xF);
	
	return i;
}

void RTC_readtime(void)
{
	//puts("RTC_SET\r\n");
	if(RTC_read(0x6)>0xFF)	// bjNJE^ǂݏo
	{
		//puts("RTC READERR\r\n");
	}
}

bool RTC_settime(void)
{
	bool err;
	
	RTC_start();	// X^[gRfBV

	err=RTC_1write(0x64);
	if(err==TRUE) err=RTC_1write(0x00);	// AhXZbg(0x00)
	if(err==TRUE) err=RTC_1write(byte2bcd(clock.ss));
	if(err==TRUE) err=RTC_1write(byte2bcd(clock.mm));
	if(err==TRUE) err=RTC_1write(byte2bcd(clock.hh));
	if(err==TRUE) err=RTC_1write(byte2bcd(clock.we));
	if(err==TRUE) err=RTC_1write(byte2bcd(clock.dy));
	if(err==TRUE) err=RTC_1write(byte2bcd(clock.mn));
	if(err==TRUE) err=RTC_1write(byte2bcd(clock.ye));

	RTC_stop();		// XgbvRfBV
	
	return err;
}


void RTC_init(void)
{
	unsigned char a;

	if((RTC_read(0xF)& 0xFF10)!=0)
	{
		// U~ĂAWX^
		RTC_reset();
		//puts("RTC RESET\r\n");
		//break;
	}

	waitms(1000);	// ԂJȂRTC̓ǂݏoAhX

	RTC_readtime();
	
	intf0=0b00_00_11_00;	// INT1̓tB^ f32
	iscr0=0b00_00_00_00;	// INT1̓GbWI 00: 01:オ 11:GbW
	ilvlc=0b0001_0001;		// INT1 荞ݗD惌x1 TIMER RB 荞ݗD惌x1
	inten=0b0000_0010;		// INT1 荞݋
}

void RTC_reset(void)
{
	RTC_write(0x0,0x00);	// bJE^
	RTC_write(0x1,0x00);	// JE^
	RTC_write(0x2,0x12);	// JE^
	RTC_write(0x3,0x00);	// jJE^
	RTC_write(0x4,0x01);	// JE^
	RTC_write(0x5,0x01);	// JE^
	RTC_write(0x6,0x12);	// NJE^
	RTC_write(0x7,0x00);	// NX^I^v덷␳
							//   0x00 ␳Ȃ
							//   0x02 琔𑝂₷ƁAx
							//   0x7F 琔炷ƁAi
	RTC_write(0x8,0x00);	// Alarm_A WX^
	RTC_write(0x9,0x00);	// Alarm_A WX^
	RTC_write(0xA,0x00);	// Alarm_A jWX^
	RTC_write(0xB,0x00);	// Alarm_B WX^
	RTC_write(0xC,0x00);	// Alarm_B WX^
	RTC_write(0xD,0x00);	// Alarm_B jWX^
	RTC_write(0xE,0x03);	// INTRA1HzpXo
	RTC_write(0xF,0x30);	// 24ԕ\A
}

bool RTC_write(unsigned char address,unsigned char data)
{
	bool err;
	
	RTC_start();

	err=RTC_1write(0x64);
	if(err==TRUE) err=RTC_1write(((address & 0x0F) << 4) & 0xF0);
	if(err==TRUE) err=RTC_1write(data);

	RTC_stop();
		
	return err;
}

// w背WX^̓ǂݎ
// ߂l 0xFF 傫G[
unsigned int RTC_read(unsigned char addr)
{
	unsigned int ret;
	unsigned char reg;
	unsigned char count;

	addr=addr&0xF;
	for(count=0; count<10; count++)	// G[10܂ŃgC
	{
		RTC_start();
	
		if (RTC_1write(0x65)==TRUE)
		{
			reg=0xF;	// WX^̏l0xF
			while(TRUE)
			{
				//puthex(reg); putch(' ');
				ret=RTC_1read();
				
				// vWX^AłɃZbg
				DI();	// ԃZbg̊Ԋ荞݋֎~
				switch(reg)
				{
					case 0:
						clock.ss=bcd2int(ret);
						break;
					case 1:
						clock.mm=bcd2int(ret);
						break;
					case 2:
						clock.hh=bcd2int(ret);
						break;
					case 3:
						clock.we=ret;
						break;
					case 4:
						clock.dy=bcd2int(ret);
						break;
					case 5:
						clock.mn=bcd2int(ret);
						break;
					case 6:
						clock.ye=bcd2int(ret);
						break;
				}
				EI();	// 荞݋
				
				if(addr==reg) break;	// w̃AhXǂ񂾂I
				reg=(reg+1)&0xF;

				RTC_ACKout();
			}
		}
		else
		{
			ret=0xFFFF;	// G[
		}
	
		RTC_stop();
		
		if(ret<0x100) 
		{
			//puts("RTC READ OK ");
			//puthexshort(ret);
			//puts("\r\n");
			return ret;	// G[ȂI
		}
		
		waitms(1);	// G[AԂĂ烊gC
	}
	
	//puts("RTC READ ERR\r\n");
	return 0xFFFF;	// gCĂG[
}

// INT1 荞
// 1b
#pragma INTERRUPT INT1_1HZ (vect=25)
void INT1_1HZ(void)
{
	clock.ss++;
	if(clock.ss>59)
	{
		clock.ss=0;
		clock.mm++;
		if(clock.mm>59)
		{
			clock.mm=0;
			clock.hh++;
			if(clock.hh>23)
			{
				RTC_readtime();
			}
		}
	}

	// INT荞݂́A荞݃[`ɃWv_ŎIɗvtONÂ
	// tÕNA͂ȂĂ
	while(iri1==1) iri1=0;	// 荞ݗvtONA
}

